/*******************************************************************************
*  skAPDS9960.h - WFX`[ZT(APDS9960)֐Cũwb_t@C  *
*                                                                              *
* ============================================================================ *
*   VERSION  DATE        BY                    CHANGE/COMMENT                  *
* ---------------------------------------------------------------------------- *
*   1.00     2015-12-25  ޒH[     Create                                 *
*   1.10     2016-03-08  ޒH[     \(0xA2/A3)`̃~XC        *
* ============================================================================ *
*   Arduino IDE 1.7.3 (Ardino Duemilanove 328/UNO ZERO/M0)                     *
*******************************************************************************/
#ifndef _SKAPDS9960_H_
#define _SKAPDS9960_H_

#include "arduino.h"


#define PON_ON				1		// ŰN
#define PON_OFF			0		// U̒~(d̓X[v[h)


#define GDATA_LOW_BORDER		10		// WFX`[f[^̒჌xEl(ȉ̓mCYƂ)
#define WTIME_50ms			238		// EGCg^C(d͎ɂ鎞Ԃ̗)50msɐݒ
// WFX`[WX^̒萔`
#define GWTIME_2_8ms		1		// WFX`[EGCg2.8msɐݒ
#define GPULSE_12ps			11		// WFX`[(LED)pX̔"12"ɐݒ
#define GPLEN_16us			2		// WFX`[(LED)pX1TCN16usɐݒ
#define GLDRIVE_100mA		0		// WFX`[LEDhCud100mAɐݒ
#define GGAIN_8x			3		// WFX`[QCRg[͂W{ɐݒ
#define GFIFOTH_16ko		3         // FIFO16f[^܂(GVALID)
// ߐڃWX^̒萔`
#define PPULSE_8ps			7		// ߐ(LED)pX̔"8"ɐݒ
#define PPLEN_8us			1		// ߐ(LED)pX1TCN8usɐݒ
#define LEDBOOST_100pa		0		// LEDhCud̑100%ɐݒ
#define LDRIVE_100mA		0		// ߐLEDhCud100mAɐݒ
#define PGAIN_4x			2		// ߐڃQCRg[͂S{ɐݒ
// FEƓxWX^̒萔`
#define AGAIN_4x			1		// ALSQCRg[͂S{ɐݒ
#define ATIME_100ms			220		// ALŠv(ώZ)鎞Ԃ100msɐݒ


// foCX̃WX^AhX
#define APDS_ID_ADRS		0x92		// foCX̎IDi[WX^
#define APDS_ENABLE_ADRS		0x80		// @\̑IWX^(ALS,ߐ,WFX`[)
#define APDS_WTIME_ADRS		0x83		// EGCgWX^(ALS,ߐ,WFX`[)
#define APDS_PPULSE_ADRS		0x8E		// ߐڃpXJEgWX^(ߐ,WFX`[)
#define APDS_CONFIG2_ADRS	0x90		// RtBOQWX^(ALS,ߐ,WFX`[)

#define APDS_CONTROL1_ADRS	0x8F		// 䃌WX^(ALS,ߐ)
#define APDS_PERS_ADRS		0x8C		// ݒʒm@̑IWX^(ALS,ߐ)
#define APDS_STATUS_ADRS		0x93		// ԕ\WX^
#define APDS_PDATA_ADRS		0x9C		// ߐڂ̃f[^i[WX^
#define APDS_PICLEAR_ADRS	0xE5		// ߐڂ̊荞݉WX^
#define APDS_PILT_ADRS		0x89		// ߐڂ̒჌x臒lWX^
#define APDS_PIHT_ADRS		0x8B		// ߐڂ̍x臒lWX^
#define APDS_AILHT_ADRS		0x84		// ALS̐擪̊臒lWX^
#define APDS_CICLEAR_ADRS	0xE6		// ALS̊荞݉WX^
#define APDS_CDATA_ADRS		0x94		// ALS̐擪f[^i[WX^
#define APDS_ATIME_ADRS		0x81		// ALŠv(ώZ)ԃWX^

#define APDS_GCONFIG1_ADRS	0xA2		// WFX`[RtBOPWX^
#define APDS_GCONFIG2_ADRS	0xA3		// WFX`[RtBOQWX^
#define APDS_GPULSE_ADRS		0xA6		// WFX`[pXJEgWX^
#define APDS_GCONFIG4_ADRS	0xAB		// WFX`[RtBOSWX^
#define APDS_FIFOSU_ADRS		0xAE		// WFX`[FIFOf[^WX^
#define APDS_GSTATUS_ADRS	0xAF		// WFX`[ԕ\WX^
#define APDS_UFIFO_ADRS		0xFC		// WFX`[UPf[^i[WX^


// WX^̍\̒`
// Enable Register (0x80)
union Enable_t {                        // @\̑IWX^
     unsigned char DT ;
     struct {
          unsigned PON          :1 ;    // UON/OFF(d̓X[v)
          unsigned AEN          :1 ;    // ALS@\̗L
          unsigned PEN          :1 ;    // ߐڌo@\̗L
          unsigned WEN          :1 ;    // EFCg@\̗L
          unsigned AIEN         :1 ;    // ALS荞݂̗L
          unsigned PIEN         :1 ;    // ߐڊ荞݂̗L
          unsigned GEN          :1 ;    // WFX`[@\̗L
          unsigned SP1          :1 ;
     } ;
} ;
// Persistence Register (0x8C)
union Persistence_t {                   // ݒʒm@̑IWX^
     unsigned char DT ;
     struct {
          unsigned APERS       :4 ;     // ALS
          unsigned PPERS       :4 ;     // ߐڊ
     } ;
} ;
// Proximity/Gesture Pulse Count Register (0x8E/0xA6)
union PulseCount_t {                    // ߐ/WFX`[ pXJEgWX^
     unsigned char DT ;
     struct {
          unsigned PULSE       :6 ;     // LEDpXJEg
          unsigned PLEN        :2 ;     // LEDpX̎
     } ;
} ;
// Control Register One (0x8F)
union Control1_t {                      // 䃌WX^
     unsigned char DT ;
     struct {
          unsigned AGAIN        :2 ;    // ALSQCRg[
          unsigned PGAIN        :2 ;    // ߐڃQCRg[
          unsigned SP1          :2 ;
          unsigned LDRIVE       :2 ;    // LEDhCud̎w
     } ;
} ;
// Configuration Register Two (0x90)
union Config2_t {                       // RtBOQWX^
     unsigned char DT ;
     struct {
          unsigned SP2          :1 ;    // "1"Zbg
          unsigned SP1          :3 ;
          unsigned LED_BOOST    :2 ;    // LEDhCud𑝉
          unsigned CPSIEN       :1 ;    // NA`lOa荞ݗL
          unsigned PSIEN        :1 ;    // ߐږOa荞ݗL
     } ;
} ;
// Status Register (0x93)
union Status_t {                        // ԕ\WX^
     unsigned char DT ;
     struct {
          unsigned AVALID       :1 ;    // ALSf[^L
          unsigned PVALID       :1 ;    // ߐڃf[^L
          unsigned GINT         :1 ;    // WFX`[荞
          unsigned SP1          :1 ;
          unsigned AINT         :1 ;    // ALS荞
          unsigned PINT         :1 ;    // ߐڊ荞
          unsigned PGSAT        :1 ;    // AiOZT̖OaCxg荞
          unsigned CPSAT        :1 ;    // NAtHg_CI[h̖OaCxg荞
     } ;
} ;
// Gesture Configuration One Register (0xA2)
union GConfig1_t {                      // WFX`[RtBOPWX^
     unsigned char DT ;
     struct {
          unsigned GEXPERS      :2 ;    // WFX`[I܂ł̉
          unsigned GEXMSK       :4 ;    // WFX`[̏I}XN
          unsigned GFIFOTH      :2 ;    // WFX`[FIFOl
     } ;
} ;
// Gesture Configuration Two Register (0xA3)
union GConfig2_t {                      // WFX`[RtBOQWX^
     unsigned char DT ;
     struct {
          unsigned GWTIME       :3 ;    // WFX`[̑ҋ@
          unsigned GLDRIVE      :2 ;    // LEDhCud̎w
          unsigned GGAIN        :2 ;    // WFX`[QCRg[
          unsigned SP1          :1 ;
     } ;
} ;
// Gesture Configuration Four Register (0xAB)
union GConfig4_t {                      // WFX`[RtBOSWX^
     unsigned char DT ;
     struct {
          unsigned GMODE        :1 ;    // WFX`[[h
          unsigned GIEN         :1 ;    // WFX`[֘A荞݂̗L
          unsigned GFIFO_CLR    :1 ;    // WFX`[֘A荞݂̃NA
          unsigned SP1          :5 ;
     } ;
} ;
// Gesture Status Register (0xAF)
union GStatus_t {                       // WFX`[ԕ\WX^
     unsigned char DT ;
     struct {
          unsigned GVALID       :1 ;    // WFX`[FIFOf[^L
          unsigned GFOV         :1 ;    // WFX`[FIFOI[o[t[
          unsigned SP1          :6 ;
     } ;
} ;

// ֐̃vg^Cv錾
/*******************************************************************************
*	NX̒`                                                              *
*******************************************************************************/
class skAPDS9960
{
  private:
     int  device_id ;
     int  device_adrs ;
     int  SurveyFlag ;
     int  SensorHighValue ;
     unsigned char GestureBuf[32][4] ;

     int  GestureDataSurvey(int kosu) ;
     int  Send(char reg_adrs,unsigned char *data,char kosu) ;
     int  Receive(char reg_adrs,unsigned char *data,char kosu) ;

  public:
          skAPDS9960(int id,int address) ;
     int  Init() ;
     int  PowerOnOff(int mode) ;
     int  ColorStart(int inter,uint16_t iht,uint16_t ilt) ;
     int  ColorStop() ;
     int  ColorRead(uint16_t *cdata) ;
     int  ProximityStart(int inter,uint16_t iht,uint16_t ilt) ;
     int  ProximityStop() ;
     int  ProximityRead(unsigned char *pdata) ;
     int  GestureStart(int inter) ;
     int  GestureStop() ;
     int  GestureRead(unsigned char *gdata) ;
} ;

#endif
