/*******************************************************************************
*  skAPDS9960 - WFX`[ZT(APDS9960)֐Cu                    *
*               ̃ZT́AFƏƓx̌oAߐڌoƃWFX`[o *
*                                                                              *
*    skAPDS9960 - ̊֐Cu𐶐鎞̏                   *
*    Init       - foCX̏s                                   *
*    Send       - foCXɎw̃f[^𑗐M鏈                     *
*    Receive    - foCXw̃f[^M鏈                   *
*    PowerOnOff - ŰNƒ~鏈                           *
*    ColorStart     - FEƓx(ALS)o@\Jn鏈                      *
*    ColorStop      - FEƓx(ALS)o@\~鏈                    *
*    ColorRead      - FEƓx(ALS)ZŤof[^ǂݍޏ            *
*    ProximityStart - ߐڌo@\Jn鏈                               *
*    ProximityStop  - ߐڌo@\~鏈                             *
*    ProximityRead  - ߐڃZŤof[^ǂݍޏ                     *
*    GestureStart   - WFX`[o@\Jn鏈                       *
*    GestureStop    - WFX`[o@\~鏈                     *
*    GestureRead    - WFX`[ZŤof[^ǂݍޏ             *
* ============================================================================ *
*   VERSION  DATE        BY             CHANGE/COMMENT                         *
* ---------------------------------------------------------------------------- *
*   1.00     2015-12-25  ޒH[     Create                                 *
* ============================================================================ *
*   Arduino IDE 1.7.3 (Ardino Duemilanove 328/UNO ZERO/M0)                     *
*******************************************************************************/
#include <Wire.h>
#include "arduino.h"
#include "skAPDS9960.h"


/*******************************************************************************
*  skAPDS9960(id,address)                                                      *
*    ̊֐Cu𐶐鎞̏(RXgN^)                *
*    id      : foCX̎IDw肵܂                                    *
*    address : foCX(X[u)I2CAhXw肵܂                     *
*******************************************************************************/
skAPDS9960::skAPDS9960(int id ,int address)
{
     device_id   = id ;
     device_adrs = address ;
}
/*******************************************************************************
*  ans = Init()                                                                *
*    foCX̏s                                                *
*    foCX́Ad̓X[v[hŋNĂ܂B                        *
*    ans  : ߂lA0=I@ȊOI2CʐMG[L                      *
*                   1=낤Ƃf[^Mobt@̃TCY𒴂         *
*                   2=X[uEAhX𑗐MANACKM               *
*                   3=f[^EoCg𑗐MANACKM                   *
*                   4=̑̃G[                                           *
*                   5=f[^MG[                                         *
*                   6=foCXID`FbNG[                               *
*******************************************************************************/
int skAPDS9960::Init()
{
     int  ans ;
     unsigned char data[2] ;
     union Enable_t enable ;

     // foCX̎ʂhc`FbN鏈
     ans = Receive(APDS_ID_ADRS,&data[0],1) ;
     if (ans == 0) {
          // ID̓e`FbN
          if (data[0] == device_id) {
               // hcvȂfoCX

               // EGCg^CWX^Ƀf[^
               data[0] = WTIME_50ms ;   // d͎ɂ鎞Ԃ̗ʂ50msɐݒ
               Send(APDS_WTIME_ADRS,&data[0],1) ;
               // @\̑IWX^Ƀf[^
               enable.DT  = 0 ;
               enable.PON = 0 ;         // UOFF(d̓X[v)
               enable.WEN = 1 ;         // EFCg@\LƂ
               data[0] = enable.DT ;
               Send(APDS_ENABLE_ADRS,&data[0],1) ;

          } else ans = 6 ;// hcvȂ
     }

     return ans ;
}
/*******************************************************************************
*  ans = PowerOnOff(mode)                                                      *
*  ŰNƒ~鏈                                          *
*  ~ƒd̓X[v[hɂȂ܂I2C͒ʐM\łB             *
*  ̊֐ĂԑOɁAeo@\~ĉB                          *
*    mode : 0(PON_OFF)=~  1(PON_ON)=N                                    *
*    ans  : ߂lA0=I@ȊO Init() anslQ                  *
*******************************************************************************/
int skAPDS9960::PowerOnOff(int mode)
{
     int ans ;
     unsigned char data[2] ;
     union Enable_t enable ;

     // @\̑IWX^猻̃f[^ǂݍ
     ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
     if (ans == 0) {
          enable.DT = data[0] ;
          enable.PON = mode ;       // UON/OFF
          data[0] = enable.DT ;
          // @\̑IWX^Ƀf[^
          Send(APDS_ENABLE_ADRS,&data[0],1) ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = ColorRead(*cdata)                                                     *
*  FEƓx(ALS)ZŤof[^ǂݍޏ                               *
*  cdatáhclear,red,green,blueh4̃f[^(2oCgÂ)Ԃ܂B       *
*    *cdata   : ǂݍ񂾃f[^(8oCg)̊i[w肷                    *
*    ans      : ߂lA0=I  7=of[^͖ł                   *
*                       ȊO Init() anslQ                          *
*******************************************************************************/
int skAPDS9960::ColorRead(uint16_t *cdata)
{
     int ans ;
     unsigned char data[2] ;
     union Status_t sts ;

     // ԕ\WX^ǂݍ
     ans = Receive(APDS_STATUS_ADRS,&data[0],1) ;
     if (ans == 0) {
          sts.DT = data[0] ;
          // FEƓx(ALS)ZŤof[^LȂAZTlǂݏo
          if (sts.AVALID == 1) {
               Receive(APDS_CDATA_ADRS,(unsigned char *)cdata,8) ;
               if ((sts.AINT == 1)||(sts.CPSAT == 1)) {
                    // 荞ݗLȂ
                    Receive(APDS_CICLEAR_ADRS,&data[0],1) ;
               }
          } else ans = 7 ;    // of[^͖ł
     }
     return ans ;
}
/*******************************************************************************
*  ans = ColorStop()                                                           *
*  FEƓx(ALS)o@\~鏈                                       *
*    ans      : ߂lA0=I@ȊO Init() anslQ              *
*******************************************************************************/
int skAPDS9960::ColorStop()
{
     int ans ;
     unsigned char data[2] ;
     union Enable_t enable ;

     // @\̑IWX^猻̃f[^ǂݍ
     ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
     if (ans == 0) {
          enable.DT = data[0] ;
          enable.AEN  = 0 ;             // FEƓxo@\𖳌ɂ
          enable.AIEN = 0 ;             // ALS荞݂͖Ƃ
          data[0] = enable.DT ;
          // @\̑IWX^Ƀf[^
          Send(APDS_ENABLE_ADRS,&data[0],1) ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = ColorStart(inter,iht,ilt)                                             *
*  FEƓx(ALS)o@\Jn鏈                                         *
*  ilt/iht0x0-0xFFFF܂ł̒lłA0x0ɂꍇ͑SĂ̌oTCN  *
*  Ŋ荞ݔ܂B                                                      *
*  SLEEPԂIDLEֈڍsꍇ7msԊ|܂B                        *
*  ̊֐͏܂Ŗ300ms҂܂B                           *
*    inter : 1=ALSo݂̊s  0=ALSo݂̊Ȃ            *
*    iht   : ّ臒l(AIHT)ڼ޽ɐݒ肷lAgȂȂ0w      *
*    ilt   : ّ臒l(AILT)ڼ޽ɐݒ肷lAgȂȂ0w      *
*    ans   : ߂lA0=I@ȊO Init() anslQ                 *
*******************************************************************************/
int skAPDS9960::ColorStart(int inter,uint16_t iht,uint16_t ilt)
{
     int ans ;
     unsigned char data[4] ;
     union Persistence_t pers ;
     union Control1_t    ctl ;
     union Enable_t      enable ;

     // 䃌WX^猻̃f[^ǂݍ
     ans = Receive(APDS_CONTROL1_ADRS,&data[0],1) ;
     if (ans == 0) {
          // g䃌WX^hɃf[^Zbg
          ctl.DT = data[0] ;
          ctl.AGAIN = AGAIN_4x ;             // ALS(Ɠx)QCRg[̎w
          data[0] = ctl.DT ;
          // 䃌WX^Ƀf[^
          Send(APDS_PPULSE_ADRS,&data[0],1) ;
          // @\̑IWX^猻̃f[^ǂݍ
          ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
          if (ans == 0) {
               // gv(ώZ)ԃWX^hɃf[^Zbg
               data[1] = ATIME_100ms ;       // FEƓxv(ώZ)鎞Ԃw
               // g@\̑IWX^hɃf[^Zbg
               enable.DT = data[0] ;
               enable.PON = 1 ;              // UN
               enable.AEN = 1 ;              // FEƓxo@\Lɂ
               if (inter == 1) {
                    // 荞ݏ̃Zbg
                    enable.AIEN = 1 ;        // ALS荞݂͗LƂ
                    // 荞臒l̃Zbg
                    data[0] = (unsigned char)(ilt & 0x00FF) ;    // ჌x臒l
                    data[1] = (unsigned char)((ilt & 0xFF00) >> 8) ;
                    data[2] = (unsigned char)(iht & 0x00FF) ;    // x臒l
                    data[3] = (unsigned char)((iht & 0xFF00) >> 8) ;
                    Send(APDS_AILHT_ADRS,&data[0],4) ;
                    // 荞臒l𗘗p̂w肷
                    Receive(APDS_PERS_ADRS,&data[0],1) ;
                    pers.DT = data[0] ;
                    if ((ilt > 0)||(iht > 0)) pers.APERS = 1 ;   // g
                    else                      pers.APERS = 0 ;   // gȂ
                    data[0] = pers.DT ;
                    Send(APDS_PERS_ADRS,&data[0],1) ;
               } else enable.AIEN = 0 ;      // ALS荞݂͖Ƃ
               data[0] = enable.DT ;
               // @\̑IWX^ƌv(ώZ)ԃWX^Ƀf[^
               Send(APDS_ENABLE_ADRS,&data[0],2) ;
               // ܂ő҂
               delay(300) ;
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = ProximityRead(*pdata)                                                 *
*  ߐڃZŤof[^ǂݍޏ                                        *
*    *pdata   : ǂݍ񂾃f[^̊i[w肷                             *
*    ans      : ߂lA0=I  7=of[^͖ł                   *
*                       ȊO Init() anslQ                          *
*******************************************************************************/
int skAPDS9960::ProximityRead(unsigned char *pdata)
{
     int ans ;
     unsigned char data[2] ;
     union Status_t sts ;

     // ԕ\WX^ǂݍ
     ans = Receive(APDS_STATUS_ADRS,&data[0],1) ;
     if (ans == 0) {
          sts.DT = data[0] ;
          // ߐڃZŤof[^LȂAZTlǂݏo
          if (sts.PVALID == 1) {
               Receive(APDS_PDATA_ADRS,&data[1],1) ;
               *pdata = data[1] ;
               if ((sts.PINT == 1)||(sts.PGSAT == 1)) {
                    // 荞ݗLȂ
                    Receive(APDS_PICLEAR_ADRS,&data[0],1) ;
               }
          } else ans = 7 ;    // of[^͖ł
     }
     return ans ;
}
/*******************************************************************************
*  ans = ProximityStop()                                                       *
*  ߐڌo@\~鏈                                                *
*    ans      : ߂lA0=I@ȊO Init() anslQ              *
*******************************************************************************/
int skAPDS9960::ProximityStop()
{
     int ans ;
     unsigned char data[2] ;
     union Enable_t enable ;

     // @\̑IWX^猻̃f[^ǂݍ
     ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
     if (ans == 0) {
          enable.DT = data[0] ;
          enable.PEN  = 0 ;             // ߐڌo@\𖳌ɂ
          enable.PIEN = 0 ;             // ߐڊ荞݂͖Ƃ
          data[0] = enable.DT ;
          // @\̑IWX^Ƀf[^
          Send(APDS_ENABLE_ADRS,&data[0],1) ;
     }
     return ans ;
}
/*******************************************************************************
*  ans = ProximityStart(inter,iht,ilt)                                         *
*  ߐڌo@\Jn鏈                                                  *
*  ilt/iht0x00-0xFF܂ł̒lłA0x00ɂꍇ͑SĂ̌oTCN  *
*  Ŋ荞ݔ܂B                                                      *
*  SLEEPԂIDLEֈڍsꍇ7msԊ|܂B                        *
*  ̊֐͏܂Ŗ300ms҂܂B                           *
*    inter : 1=ߐڌo݂̊s  0=ߐڌo݂̊Ȃ          *
*    iht   : ّ臒l(PIHT)ڼ޽ɐݒ肷lAgȂȂ0w      *
*    ilt   : ّ臒l(PILT)ڼ޽ɐݒ肷lAgȂȂ0w      *
*    ans   : ߂lA0=I@ȊO Init() anslQ                 *
*******************************************************************************/
int skAPDS9960::ProximityStart(int inter,uint16_t iht,uint16_t ilt)
{
     int ans ;
     unsigned char data[2] ;
     union Persistence_t pers ;
     union PulseCount_t  pls ;
     union Control1_t    ctl ;
     union Config2_t     conf ;
     union Enable_t      enable ;

     // ߐڃpXJEgWX^Ɛ䃌WX^猻̃f[^ǂݍ
     ans = Receive(APDS_PPULSE_ADRS,&data[0],2) ;
     if (ans == 0) {
          // gߐڃpXJEgWX^hɃf[^Zbg
          pls.DT = data[0] ;
          pls.PLEN  = PPLEN_8us ;                 // LEDpX̎Ԃ̎w
          pls.PULSE = PPULSE_8ps ;                // LED)XJEg̎w
          data[0] = pls.DT ;
          // g䃌WX^hɃf[^Zbg
          ctl.DT = data[1] ;
          ctl.LDRIVE = LDRIVE_100mA ;             // LEDhCud̎w
          ctl.PGAIN  = PGAIN_4x ;                 // ߐڃQCRg[̎w
          data[1] = ctl.DT ;
          // ߐڃpXJEgWX^Ɛ䃌WX^Ƀf[^
          Send(APDS_PPULSE_ADRS,&data[0],2) ;
          // RtBOQWX^猻̃f[^ǂݍ
          ans = Receive(APDS_CONFIG2_ADRS,&data[0],1) ;
          if (ans == 0) {
               // gRtBOQWXh^Ƀf[^Zbg
               conf.DT = data[0] ;
               conf.LED_BOOST = LEDBOOST_100pa ;  // LEDhCud̑(%)̎w
               data[0] = conf.DT ;
               // RtBOQWX^Ƀf[^
               Send(APDS_CONFIG2_ADRS,&data[0],1) ;
               // @\̑IWX^猻̃f[^ǂݍ
               ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
               if (ans == 0) {
                    // g@\̑IWX^hɃf[^Zbg
                    enable.DT = data[0] ;
                    enable.PON = 1 ;              // UN
                    enable.PEN = 1 ;              // ߐڌo@\Lɂ
                    if (inter == 1) {
                         // 荞ݏ̃Zbg
                         enable.PIEN = 1 ;        // ߐڊ荞݂͗LƂ
                         // 荞臒l̃Zbg
                         data[0] = (unsigned char)ilt ;     // ჌x臒l
                         Send(APDS_PILT_ADRS,&data[0],1) ;
                         data[0] = (unsigned char)iht ;     // x臒l
                         Send(APDS_PIHT_ADRS,&data[0],1) ;
                         // 荞臒l𗘗p̂w肷
                         Receive(APDS_PERS_ADRS,&data[0],1) ;
                         pers.DT = data[0] ;
                         if ((ilt > 0)||(iht > 0)) pers.PPERS = 1 ;   // g
                         else                      pers.PPERS = 0 ;   // gȂ
                         data[0] = pers.DT ;
                         Send(APDS_PERS_ADRS,&data[0],1) ;
                    } else enable.PIEN = 0 ;      // ߐڊ荞݂͖Ƃ
                    data[0] = enable.DT ;
                    // @\̑IWX^Ƀf[^
                    Send(APDS_ENABLE_ADRS,&data[0],1) ;
                    // ܂ő҂
                    delay(300) ;
               }
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = GestureRead(*gdata)                                                   *
*  WFX`[ZŤof[^ǂݍޏ                                *
*    *gdata   : ǂݍ񂾃f[^̉͌ʒli[w肷                   *
*               'U''D''L''R'=ړZbg  0=ړωȂ        *
*    ans      : ߂lA0=I  7=of[^͖ł                   *
*                       ȊO Init() anslQ                          *
*******************************************************************************/
int skAPDS9960::GestureRead(unsigned char *gdata)
{
     unsigned char udlr[5]={0,'D','U','R','L'} ;
     int ans , i ;
     unsigned char data[2] ;
     union GStatus_t gsts ;

     // FIFOxƃWFX`[ԕ\WX^ǂݍ
     ans = Receive(APDS_FIFOSU_ADRS,&data[0],2) ;
     if (ans == 0) {
          gsts.DT = data[1] ;
          // WFX`[ZŤof[^LȂAZTl(UDLR)ǂݏo
          if (gsts.GVALID == 1) {
               // FIFÕf[^ۑǂݏo
               for (i=0 ; i<data[0] ; i++) {
                    ans = Receive(APDS_UFIFO_ADRS,&GestureBuf[i][0],4) ;
               }
               // f[^lɂ"㉺E"̈ړ𒲂ׂ
               *gdata = udlr[GestureDataSurvey(data[0])] ;
          } else ans = 7 ;    // of[^͖ł
     }
     return ans ;
}
/*******************************************************************************
*  ans = GestureDataSurvey(kosu)                                               *
*  f[^lɂ"㉺E"̈ړ𒲂ׂ鏈                              *
*    kosu  : ǂݍ񂾃f[^̌(FIFOx)                                *
*    ans   : ǂݍ񂾃f[^̉͌ʒlԂ                                *
*            'U''D''L''R'=ړZbg  0=ړωȂ           *
*******************************************************************************/
int skAPDS9960::GestureDataSurvey(int kosu)
{
     int i , j , ans ;

     ans = 0 ;
     // ǂݎf[^̌ׂ
     for (i=0 ; i<kosu ; i++) {
          // WFX`[̃f[^𒲂ׂׂ̊JnƏItÕZbg
          if ((GestureBuf[i][0]>GDATA_LOW_BORDER)&&(GestureBuf[i][1]>GDATA_LOW_BORDER)&&
              (GestureBuf[i][2]>GDATA_LOW_BORDER)&&(GestureBuf[i][3]>GDATA_LOW_BORDER)) {
               SurveyFlag = 1 ;    // Jn
          }
          if ((GestureBuf[i][0]<GDATA_LOW_BORDER)&&(GestureBuf[i][1]<GDATA_LOW_BORDER)&&
              (GestureBuf[i][2]<GDATA_LOW_BORDER)&&(GestureBuf[i][3]<GDATA_LOW_BORDER)) {
               if (SurveyFlag == 1) ans = SensorHighValue+1 ;
               SurveyFlag = 0 ;    // I
               break ;
          }
          // eUDLRZTŒl̈ԑ傫ZTT
          if (SurveyFlag == 1) {
               SensorHighValue = 0 ;
               for (j=0 ; j<4 ; j++) {
                    if (GestureBuf[i][SensorHighValue] < GestureBuf[i][j]) SensorHighValue = j ;
               }
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = GestureStop()                                                         *
*  WFX`[o@\~鏈                                        *
*    ans      : ߂lA0=I@ȊO Init() anslQ              *
*******************************************************************************/
int skAPDS9960::GestureStop()
{
     int ans ;
     unsigned char data[2] ;
     union GConfig4_t gconf4 ;
     union Enable_t   enable ;
     union Status_t   sts ;

     // WFX`[RtBOSWX^猻̃f[^ǂݍ
     ans = Receive(APDS_GCONFIG4_ADRS,&data[0],1) ;
     if (ans == 0) {
          // gWFX`[RtBOSWX^hɃf[^Zbg
          gconf4.DT = data[0] ;
          gconf4.GMODE = 0 ;       // WFX`[[h
          gconf4.GIEN  = 0 ;       // WFX`[荞݂͖Ƃ
          data[0] = gconf4.DT ;
          // WFX`[RtBOSWX^Ƀf[^
          Send(APDS_GCONFIG4_ADRS,&data[0],1) ;
          // @\̑IWX^猻̃f[^ǂݍ
          ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
          if (ans == 0) {
               enable.DT = data[0] ;
               enable.PEN = 0 ;              // ߐڌo@\𖳌ɂ
               enable.GEN = 0 ;              // WFX`[o@\𖳌ɂ
               data[0] = enable.DT ;
               // @\̑IWX^Ƀf[^
               Send(APDS_ENABLE_ADRS,&data[0],1) ;
               // WFX`[荞݂Ă邩ԕ\WX^𒲂ׂ
               Receive(APDS_STATUS_ADRS,&data[0],1) ;
               sts.DT = data[0] ;
               if (sts.GINT == 1) {
                    // FIFOf[^ǂ݂NA
                    GestureRead(&data[0]) ;
               }
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = GestureStart(inter)                                                   *
*  WFX`[o@\Jn鏈                                          *
*  SLEEPԂIDLEֈڍsꍇ7msԊ|܂B                        *
*    inter    : 1=o݂̊s  0=o݂̊Ȃ               *
*    ans      : ߂lA0=I@ȊO Init() anslQ              *
*******************************************************************************/
int skAPDS9960::GestureStart(int inter)
{
     int ans ;
     unsigned char data[2] ;
     union PulseCount_t pls ;
     union GConfig1_t   gconf1 ;
     union GConfig2_t   gconf2 ;
     union GConfig4_t   gconf4 ;
     union Config2_t    conf ;
     union Enable_t     enable ;

     SurveyFlag = 0 ;
     // WFX`[pXJEgWX^猻̃f[^ǂݍ
     ans = Receive(APDS_GPULSE_ADRS,&data[0],1) ;
     if (ans == 0) {
          // gWFX`[pXJEgWX^hɃf[^Zbg
          pls.DT = data[0] ;
          pls.PLEN  = GPLEN_16us ;                // LEDpX̎Ԃ̎w
          pls.PULSE = GPULSE_12ps ;               // LEDpXJEg̎w
          data[0] = pls.DT ;
          // WFX`[pXJEgWX^Ƀf[^
          Send(APDS_GPULSE_ADRS,&data[0],1) ;
          // RtBOQWX^猻̃f[^ǂݍ
          ans = Receive(APDS_CONFIG2_ADRS,&data[0],1) ;
          if (ans == 0) {
               // gRtBOQWX^hɃf[^Zbg
               conf.DT = data[0] ;
               conf.LED_BOOST = LEDBOOST_100pa ;  // LEDhCud̑(%)̎w
               data[0] = conf.DT ;
               // RtBOQWX^Ƀf[^
               Send(APDS_CONFIG2_ADRS,&data[0],1) ;
               // WFX`[RtBOPƂQWX^猻̃f[^ǂݍ
               ans = Receive(APDS_GCONFIG1_ADRS,&data[0],2) ;
               if (ans == 0) {
                    // gWFX`[RtBOPWXh^Ƀf[^Zbg
                    gconf1.DT = data[0] ;
                    gconf1.GFIFOTH = GFIFOTH_16ko ;    // FIFO̕ۑ񍐃x
                    data[0] = gconf1.DT ;
                    // gWFX`[RtBOQWXh^Ƀf[^Zbg
                    gconf2.DT = data[1] ;
                    gconf2.GLDRIVE = GLDRIVE_100mA ;   // LEDhCud̎w
                    gconf2.GGAIN   = GGAIN_8x ;        // ߐڃQCRg[̎w
                    gconf2.GWTIME  = GWTIME_2_8ms ;    // WFX`[EGCg̎w
                    data[1] = gconf2.DT ;
                    // WFX`[RtBOPƂQWX^Ƀf[^
                    Send(APDS_GCONFIG1_ADRS,&data[0],2) ;
               }
          }
          if (ans != 0) return ans ;
          // WFX`[RtBOSWX^猻̃f[^ǂݍ
          ans = Receive(APDS_GCONFIG4_ADRS,&data[0],1) ;
          if (ans == 0) {
               // gWFX`[RtBOSWX^hɃf[^Zbg
               gconf4.DT = data[0] ;
               gconf4.GMODE = 1 ;                 // WFX`[[hɐݒ肷
               if (inter == 1) {
                    // 荞ݏ̃Zbg
                    gconf4.GIEN = 1 ;             // WFX`[荞݂͗LƂ
                    
               } else gconf4.GIEN = 0 ;           // WFX`[荞݂͖Ƃ
               data[0] = gconf4.DT ;
               // WFX`[RtBOSWX^Ƀf[^
               Send(APDS_GCONFIG4_ADRS,&data[0],1) ;
               // @\̑IWX^猻̃f[^ǂݍ
               ans = Receive(APDS_ENABLE_ADRS,&data[0],1) ;
               if (ans == 0) {
                    // g@\̑IWX^hɃf[^Zbg
                    enable.DT = data[0] ;
                    enable.PON = 1 ;              // UN
                    enable.PEN = 1 ;              // ߐڌo@\Lɂ
                    enable.GEN = 1 ;              // WFX`[o@\Lɂ
                    data[0] = enable.DT ;
                    // @\̑IWX^Ƀf[^
                    Send(APDS_ENABLE_ADRS,&data[0],1) ;
               }
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = Send(reg_adrs,*data,kosu)                                             *
*  foCXɎw̃f[^𑗐M鏈                                    *
*    reg_adrs : of[^̃WX^AhXw肷                       *
*               AIɏoꍇ́AoWX^̐擪AhXw       *
*    *data    : of[^̊i[w肷                                 *
*    kosu     : of[^̃oCgw肷                               *
*    ans      : ߂lA0=I@ȊO Init() anslQ              *
*******************************************************************************/
int skAPDS9960::Send(char reg_adrs,unsigned char *data,char kosu)
{
     int  ans , i ;

     Wire.beginTransmission(device_adrs) ;        // ʐM̊Jn
     Wire.write(reg_adrs) ;                       // WX^̃AhXʒm
     for (i=0 ; i<kosu ; i++) {
          Wire.write(*data) ;                     // f[^ʒm
          data++ ;
     }
     ans = Wire.endTransmission() ;               // f[^̑MƒʐM̏I
     return ans ;
}
/*******************************************************************************
*  ans = Receive(reg_adrs,*data,kosu)                                          *
*  foCXw̃f[^M鏈                                  *
*    reg_adrs : Ǐof[^̃WX^AhXw肷                       *
*               AIɓǏoꍇ́AǏoWX^̐擪AhXw       *
*    *data    : Ǐof[^̊i[w肷                               *
*    kosu     : Ǐof[^̃oCgw肷                               *
*    ans      : ߂lA0=I@ȊO Init() anslQ              *
*******************************************************************************/
int skAPDS9960::Receive(char reg_adrs,unsigned char *data,char kosu)
{
     int  ans , i ;

     Wire.beginTransmission(device_adrs) ;             // ʐM̊Jn
     Wire.write(reg_adrs) ;                            // WX^AhXw
     ans = Wire.endTransmission() ;                    // f[^̑MƒʐM̏I
     if (ans == 0) {
          ans = Wire.requestFrom(device_adrs,kosu) ;   // f[^̎Ms
          if (ans == kosu) {
               for (i=0 ; i<kosu ; i++) {
                    *data = Wire.read() ;
                    data++ ;
               }
               ans = 0 ;
          } else ans = 5 ;                             // MoCgH
     }
     return ans ;
}
